## android-platform-tools 35.0.2

=== fmtlib/test/CMakeLists.txt ===
add_subdirectory(gtest)

include(CheckSymbolExists)

set(TEST_MAIN_SRC test-main.cc gtest-extra.cc gtest-extra.h util.cc)
add_library(test-main STATIC ${TEST_MAIN_SRC})
target_include_directories(test-main PUBLIC
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>)
target_link_libraries(test-main gtest fmt)

function(add_fmt_executable name)
  add_executable(${name} ${ARGN})
  # (Wstringop-overflow) - [meta-bug] bogus/missing -Wstringop-overflow warnings
  #   https://gcc.gnu.org/bugzilla/show_bug.cgi?id=88443
  # Bogus -Wstringop-overflow warning
  #   https://gcc.gnu.org/bugzilla/show_bug.cgi?id=100395
  # [10 Regression] spurious -Wstringop-overflow writing to a trailing array plus offset
  #   https://gcc.gnu.org/bugzilla/show_bug.cgi?id=95353
  if (CMAKE_CXX_COMPILER_ID MATCHES "GNU" AND
      NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7.0)
    target_compile_options(${name} PRIVATE -Wno-stringop-overflow)
    # The linker flag is needed for LTO.
    target_link_libraries(${name} -Wno-stringop-overflow)
  endif ()
endfunction()

# Adds a test.
# Usage: add_fmt_test(name srcs...)
function(add_fmt_test name)
  cmake_parse_arguments(ADD_FMT_TEST "HEADER_ONLY;MODULE" "" "" ${ARGN})

  set(sources ${name}.cc ${ADD_FMT_TEST_UNPARSED_ARGUMENTS})
  if (ADD_FMT_TEST_HEADER_ONLY)
    set(sources ${sources} ${TEST_MAIN_SRC} ../src/os.cc)
    set(libs gtest fmt-header-only)
    if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
      set(PEDANTIC_COMPILE_FLAGS ${PEDANTIC_COMPILE_FLAGS} -Wno-weak-vtables)
    endif ()
  elseif (ADD_FMT_TEST_MODULE)
    set(libs test-main test-module)
    set_source_files_properties(${name}.cc PROPERTIES OBJECT_DEPENDS test-module)
  else ()
    set(libs test-main fmt)
  endif ()
  add_fmt_executable(${name} ${sources})
  target_link_libraries(${name} ${libs})

  # Define if certain C++ features can be used.
  if (FMT_PEDANTIC)
    target_compile_options(${name} PRIVATE ${PEDANTIC_COMPILE_FLAGS})
  endif ()
  if (FMT_WERROR)
    target_compile_options(${name} PRIVATE ${WERROR_FLAG})
  endif ()
  add_test(NAME ${name} COMMAND ${name})
endfunction()

if (FMT_MODULE)
  return ()
endif ()

add_fmt_test(args-test)
add_fmt_test(assert-test)
add_fmt_test(chrono-test)
add_fmt_test(color-test)
add_fmt_test(core-test)
add_fmt_test(gtest-extra-test)
add_fmt_test(format-test mock-allocator.h)
if (MSVC)
  target_compile_options(format-test PRIVATE /bigobj)
endif ()
if (NOT (MSVC AND BUILD_SHARED_LIBS))
  add_fmt_test(format-impl-test HEADER_ONLY header-only-test.cc)
endif ()
add_fmt_test(ostream-test)
add_fmt_test(compile-test)
add_fmt_test(compile-fp-test HEADER_ONLY)
if (MSVC)
  # Without this option, MSVC returns 199711L for the __cplusplus macro.
  target_compile_options(compile-fp-test PRIVATE /Zc:__cplusplus)
endif()
add_fmt_test(printf-test)
add_fmt_test(ranges-test ranges-odr-test.cc)

add_fmt_test(scan-test)
check_symbol_exists(strptime "time.h" HAVE_STRPTIME)
if (HAVE_STRPTIME)
  target_compile_definitions(scan-test PRIVATE FMT_HAVE_STRPTIME)
endif ()

add_fmt_test(std-test)
try_compile(compile_result_unused
            ${CMAKE_CURRENT_BINARY_DIR}
            SOURCES ${CMAKE_CURRENT_LIST_DIR}/detect-stdfs.cc
            OUTPUT_VARIABLE RAWOUTPUT)
string(REGEX REPLACE ".*libfound \"([^\"]*)\".*" "\\1" STDLIBFS "${RAWOUTPUT}")
if (STDLIBFS)
  target_link_libraries(std-test ${STDLIBFS})
endif ()
add_fmt_test(unicode-test HEADER_ONLY)
if (MSVC)
  target_compile_options(unicode-test PRIVATE /utf-8)
endif ()
add_fmt_test(xchar-test)
add_fmt_test(enforce-checks-test)
target_compile_definitions(enforce-checks-test PRIVATE
                           -DFMT_ENFORCE_COMPILE_STRING)

if (FMT_MODULE)
  # The tests need {fmt} to be compiled as traditional library
  # because of visibility of implementation details.
  # If module support is present the module tests require a
  # test-only module to be built from {fmt}
  add_library(test-module OBJECT ${CMAKE_SOURCE_DIR}/src/fmt.cc)
  target_compile_features(test-module PUBLIC cxx_std_11)
  target_include_directories(test-module PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>)
  enable_module(test-module)

  add_fmt_test(module-test MODULE test-main.cc)
  if (MSVC)
    target_compile_options(test-module PRIVATE /utf-8 /Zc:__cplusplus
                           /Zc:externConstexpr /Zc:inline)
    target_compile_options(module-test PRIVATE /utf-8 /Zc:__cplusplus
                           /Zc:externConstexpr /Zc:inline)
  endif ()
endif ()

if (NOT DEFINED MSVC_STATIC_RUNTIME AND MSVC)
  foreach (flag_var
			 CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
			 CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
	if (${flag_var} MATCHES "^(/|-)(MT|MTd)")
	  set(MSVC_STATIC_RUNTIME ON)
	  break()
	endif()
  endforeach()
endif()

if (NOT MSVC_STATIC_RUNTIME)
  add_fmt_executable(posix-mock-test
    posix-mock-test.cc ../src/format.cc ${TEST_MAIN_SRC})
  target_include_directories(
    posix-mock-test PRIVATE ${PROJECT_SOURCE_DIR}/include)
  target_link_libraries(posix-mock-test gtest)
  if (FMT_PEDANTIC)
    target_compile_options(posix-mock-test PRIVATE ${PEDANTIC_COMPILE_FLAGS})
  endif ()
  add_test(NAME posix-mock-test COMMAND posix-mock-test)
  add_fmt_test(os-test)
endif ()

message(STATUS "FMT_PEDANTIC: ${FMT_PEDANTIC}")

if (FMT_PEDANTIC)
  # Test that the library can be compiled with exceptions disabled.
  # -fno-exception is broken in icc: https://github.com/fmtlib/fmt/issues/822.
  if (NOT CMAKE_CXX_COMPILER_ID STREQUAL "Intel")
    check_cxx_compiler_flag(-fno-exceptions HAVE_FNO_EXCEPTIONS_FLAG)
  endif ()
  if (HAVE_FNO_EXCEPTIONS_FLAG)
    add_library(noexception-test ../src/format.cc noexception-test.cc)
    target_include_directories(
      noexception-test PRIVATE ${PROJECT_SOURCE_DIR}/include)
    target_compile_options(noexception-test PRIVATE -fno-exceptions)
    target_compile_options(noexception-test PRIVATE ${PEDANTIC_COMPILE_FLAGS})
  endif ()

  # Test that the library compiles without locale.
  add_library(nolocale-test ../src/format.cc)
  target_include_directories(
    nolocale-test PRIVATE ${PROJECT_SOURCE_DIR}/include)
  target_compile_definitions(
    nolocale-test PRIVATE FMT_STATIC_THOUSANDS_SEPARATOR=1)
endif ()

# These tests are disabled on Windows because they take too long.
# They are disabled on GCC < 4.9 because it can not parse UDLs without
# a space after `operator""` but that is an incorrect syntax for any more
# modern compiler.
if (FMT_PEDANTIC AND NOT WIN32 AND NOT (
    CMAKE_CXX_COMPILER_ID MATCHES "GNU" AND
    CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.9))
  # Test if incorrect API usages produce compilation error.
  add_test(compile-error-test ${CMAKE_CTEST_COMMAND}
    --build-and-test
    "${CMAKE_CURRENT_SOURCE_DIR}/compile-error-test"
    "${CMAKE_CURRENT_BINARY_DIR}/compile-error-test"
    --build-generator ${CMAKE_GENERATOR}
    --build-makeprogram ${CMAKE_MAKE_PROGRAM}
    --build-options
    "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
    "-DCMAKE_CXX_FLAGS=${CMAKE_CXX_FLAGS}"
    "-DCMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD}"
    "-DCXX_STANDARD_FLAG=${CXX_STANDARD_FLAG}"
    "-DFMT_DIR=${CMAKE_SOURCE_DIR}")

  # Test if the targets are found from the build directory.
  add_test(find-package-test ${CMAKE_CTEST_COMMAND}
    -C ${CMAKE_BUILD_TYPE}
    --build-and-test
    "${CMAKE_CURRENT_SOURCE_DIR}/find-package-test"
    "${CMAKE_CURRENT_BINARY_DIR}/find-package-test"
    --build-generator ${CMAKE_GENERATOR}
    --build-makeprogram ${CMAKE_MAKE_PROGRAM}
    --build-options
    "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
    "-DCMAKE_CXX_FLAGS=${CMAKE_CXX_FLAGS}"
    "-DCMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD}"
    "-DFMT_DIR=${PROJECT_BINARY_DIR}"
    "-DPEDANTIC_COMPILE_FLAGS=${PEDANTIC_COMPILE_FLAGS}"
    "-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}")

  # Test if the targets are found when add_subdirectory is used.
  add_test(add-subdirectory-test ${CMAKE_CTEST_COMMAND}
    -C ${CMAKE_BUILD_TYPE}
    --build-and-test
    "${CMAKE_CURRENT_SOURCE_DIR}/add-subdirectory-test"
    "${CMAKE_CURRENT_BINARY_DIR}/add-subdirectory-test"
    --build-generator ${CMAKE_GENERATOR}
    --build-makeprogram ${CMAKE_MAKE_PROGRAM}
    --build-options
    "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
    "-DCMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD}"
    "-DPEDANTIC_COMPILE_FLAGS=${PEDANTIC_COMPILE_FLAGS}"
    "-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}")
endif ()

# This test are disabled on Windows because it is only *NIX issue.
if (FMT_PEDANTIC AND NOT WIN32)
  add_test(static-export-test ${CMAKE_CTEST_COMMAND}
    -C ${CMAKE_BUILD_TYPE}
    --build-and-test
    "${CMAKE_CURRENT_SOURCE_DIR}/static-export-test"
    "${CMAKE_CURRENT_BINARY_DIR}/static-export-test"
    --build-generator ${CMAKE_GENERATOR}
    --build-makeprogram ${CMAKE_MAKE_PROGRAM}
    --build-options
    "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
    "-DCMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD}"
    "-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}")
endif ()

# Activate optional CUDA tests if CUDA is found. For version selection see
# https://docs.nvidia.com/cuda/cuda-c-programming-guide/index.html#cpp14-language-features
if (FMT_CUDA_TEST)
  if (${CMAKE_VERSION} VERSION_LESS 3.15)
    find_package(CUDA 9.0)
  else ()
    include(CheckLanguage)
    check_language(CUDA)
    if (CMAKE_CUDA_COMPILER)
      enable_language(CUDA OPTIONAL)
      set(CUDA_FOUND TRUE)
    endif ()
  endif ()

  if (CUDA_FOUND)
    add_subdirectory(cuda-test)
    add_test(NAME cuda-test COMMAND fmt-in-cuda-test)
  endif ()
endif ()

=== ide/clion/CMakeLists.txt ===
# Will add_directory the given path only if the directory exists. If the directory doesn't exist,
# it will look for either arm64-android or x86_64-android variants of the path. If it finds either, or both,
# then it will add the newer of the two.
function(try_add_subdir path)
    if(IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/${path}")
      add_subdirectory(${path})
    endif()

    set(path_arm64 ${path}-arm64-android)
    if (IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/${path_arm64}")
        set(has_arm64 TRUE)
    else()
        set(has_arm64 FALSE)
    endif()

    set(path_x64 ${path}-x86_64-android)
    if (IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/${path_x64}")
        set(has_x64 TRUE)
    else()
        set(has_x64 FALSE)
    endif()

    if (${has_arm64} AND ${has_x64})
        if ("${CMAKE_CURRENT_SOURCE_DIR}/${path_arm64}/CMakeLists.txt" IS_NEWER_THAN
                "${CMAKE_CURRENT_SOURCE_DIR}/${path_x64}/CMakeLists.txt")
            add_subdirectory(${path_arm64})
        else()
            add_subdirectory(${path_x64})
        endif()
    elseif(${has_arm64})
        add_subdirectory(${path_arm64})
    elseif(${has_x64})
        add_subdirectory(${path_x64})
    endif()
endfunction()

=== fmtlib/test/find-package-test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8...3.25)

project(fmt-test)

find_package(FMT REQUIRED)

add_executable(library-test main.cc)
target_link_libraries(library-test fmt::fmt)
target_compile_options(library-test PRIVATE ${PEDANTIC_COMPILE_FLAGS})
target_include_directories(library-test PUBLIC SYSTEM .)

if (TARGET fmt::fmt-header-only)
  add_executable(header-only-test main.cc)
  target_link_libraries(header-only-test fmt::fmt-header-only)
  target_compile_options(header-only-test PRIVATE ${PEDANTIC_COMPILE_FLAGS})
  target_include_directories(header-only-test PUBLIC SYSTEM .)
endif ()

=== ide/clion/external/minigbm/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(external_minigbm)
add_subdirectory(cros_gralloc/aidl/android.hardware.graphics.allocator-service.minigbm-x86_64-android)
add_subdirectory(cros_gralloc/mapper_stablec/mapper.minigbm-x86_64-android)
add_subdirectory(cros_gralloc/gralloc4/libminigbm_gralloc4_utils-x86_64-android)
add_subdirectory(libminigbm_gralloc-x86_64-android)

=== ide/clion/frameworks/base/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(frameworks_base)

include("${CMAKE_CURRENT_SOURCE_DIR}/../../CMakeLists.txt")

# HWUI
try_add_subdir(libs/hwui/libhwui)
try_add_subdir(libs/hwui/hwuimacro)
try_add_subdir(libs/hwui/hwuimicro)
try_add_subdir(libs/hwui/hwui_unit_tests)

# JNI
try_add_subdir(core/jni/libandroid_runtime)

=== ide/clion/frameworks/ml/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(ml)

add_subdirectory(nn/tools/ion_watcher/ion_watcher-arm-android)
add_subdirectory(nn/driver/sample/libSampleDriver-arm-android)
add_subdirectory(nn/driver/sample/android.hardware.neuralnetworks@1.2-service-sample-minimal-arm-android)
add_subdirectory(nn/driver/sample/android.hardware.neuralnetworks@1.2-service-sample-float-slow-arm-android)
add_subdirectory(nn/driver/sample/android.hardware.neuralnetworks@1.2-service-sample-all-arm-android)
add_subdirectory(nn/driver/sample/android.hardware.neuralnetworks@1.2-service-sample-float-fast-arm-android)
add_subdirectory(nn/driver/sample/android.hardware.neuralnetworks@1.2-service-sample-quant-arm-android)
add_subdirectory(nn/driver/cache/BlobCache/libBlobCache-arm-android)
add_subdirectory(nn/driver/cache/BlobCache/BlobCache_test-arm-android)
add_subdirectory(nn/driver/cache/nnCache/lib_nnCache-arm-android)
add_subdirectory(nn/driver/cache/nnCache/nnCache_test-arm-android)
add_subdirectory(nn/common/libneuralnetworks_utils-arm-android)
add_subdirectory(nn/common/random/philox_random-arm-android)
add_subdirectory(nn/common/NeuralNetworksTest_operations-arm-android)
add_subdirectory(nn/common/NeuralNetworksTest_utils-arm-android)
add_subdirectory(nn/common/libneuralnetworks_common-arm-android)
add_subdirectory(nn/runtime/test/NeuralNetworksTest_shared_partial-arm-android)
add_subdirectory(nn/runtime/test/NeuralNetworksTest_static-arm-android)
add_subdirectory(nn/runtime/test/NeuralNetworksTest_static_fuzzing-arm-android)
add_subdirectory(nn/runtime/test/NeuralNetworksTest_mt_static-arm-android)
add_subdirectory(nn/runtime/test/NeuralNetworksTest_static_asan-arm-android)
add_subdirectory(nn/runtime/test/NeuralNetworksTest_static_ubsan-arm-android)
add_subdirectory(nn/runtime/test/NeuralNetworksTest_mt_static_asan-arm-android)

=== ide/clion/frameworks/native/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(native)

include("${CMAKE_CURRENT_SOURCE_DIR}/../../CMakeLists.txt")

try_add_subdir(libs/gui/libgui)
try_add_subdir(libs/gui/tests/libgui_test)
try_add_subdir(libs/ui/libui)
try_add_subdir(libs/renderengine/librenderengine)
try_add_subdir(services/surfaceflinger/surfaceflinger)
try_add_subdir(services/surfaceflinger/CompositionEngine/libcompositionengine_mocks)
try_add_subdir(services/surfaceflinger/CompositionEngine/libcompositionengine_test)
try_add_subdir(services/surfaceflinger/CompositionEngine/libcompositionengine)
try_add_subdir(services/surfaceflinger/FrameTimeline/libframetimeline)
try_add_subdir(services/surfaceflinger/TimeStats/timestatsproto/libtimestats_proto)
try_add_subdir(services/surfaceflinger/TimeStats/libtimestats)
try_add_subdir(services/surfaceflinger/layerproto/liblayers_proto)
try_add_subdir(services/surfaceflinger/tests/IPC_test)
try_add_subdir(services/surfaceflinger/tests/fakehwc/sffakehwc_test)
try_add_subdir(services/surfaceflinger/tests/SurfaceFlinger_test)
try_add_subdir(services/surfaceflinger/tests/vsync/test-vsync-events)
try_add_subdir(services/surfaceflinger/tests/waitforvsync/test-waitforvsync)
try_add_subdir(services/surfaceflinger/tests/unittests/libsurfaceflinger_unittest)
try_add_subdir(services/surfaceflinger/libSurfaceFlingerProp)
try_add_subdir(services/surfaceflinger/sysprop/libSurfaceFlingerProperties)
try_add_subdir(services/surfaceflinger/fuzzer/surfaceflinger_fuzzer)
try_add_subdir(services/surfaceflinger/fuzzer/surfaceflinger_displayhardware_fuzzer)
try_add_subdir(services/surfaceflinger/fuzzer/surfaceflinger_scheduler_fuzzer)

=== tools/repo_diff/service/repodiff/Makefile ===
SQL_SCRIPT_DIR="tools/migrations"

DOCKER_SERVICE_NAME="repodiff-service"
DOCKER_CONTAINER_REGISTRY="gcr.io"
DOCKER_IMAGE_NAME="repodiff-image"
DOCKER_TAG_NAME="latest"
DOCKER_DOCKERFILE_DIR="."
DOCKER_TARGET_PORT=$(shell cat config.json | jq ".port")
DOCKER_CLUSTER_NAME="repodiff-default-cluster"
DOCKER_DEPLOYMENT_NAME="repodiff-deployment"
DOCKER_REPLICA_COUNT="1"

DOCKER_CANONICAL_ID=$(DOCKER_CONTAINER_REGISTRY)/$(GOOGLE_PROJECT_ID)/$(DOCKER_IMAGE_NAME):$(DOCKER_TAG_NAME)

PORT_HTTP="80"
GCE_ZONE="us-west1-b"
GCE_IMAGE_PROJECT="ubuntu-os-cloud"
GCE_IMAGE_FAMILY="ubuntu-1604-lts"

TMP_CREDENTIAL_FNAME=service_account_credentials.json

# https://cloud.google.com/compute/docs/machine-types
GCE_MACHINE_TYPE="n1-standard-64"

PROJECT_NAME="auto-diff-android-branches"
REMOTE_MACHINE_NAME=mithalop5
FIREWALL_NAME=public-http-access
DISK_SIZE=500GB
RUN_COMMAND_REMOTE=gcloud compute --project $(PROJECT_NAME) ssh --zone $(GCE_ZONE) "$(REMOTE_MACHINE_NAME)" --command
SCP_TO_HOST=gcloud compute --project $(PROJECT_NAME) scp --zone $(GCE_ZONE)
SERVICE_ACCOUNT_ID=repo-reader
SERVICE_ACCOUNT=$(SERVICE_ACCOUNT_ID)@$(PROJECT_NAME).iam.gserviceaccount.com

ifeq ($(ROLE),prod)
	GCP_DB_USER=$(GCP_DB_USER_PROD)
	GCP_DB_INSTANCE_CONNECTION_NAME=$(GCP_DB_INSTANCE_CONNECTION_NAME_PROD)
	GCP_DB_PASSWORD=$(GCP_DB_PASSWORD_PROD)
	GCP_DB_NAME=$(GCP_DB_NAME_PROD)
	GCP_DB_PROXY_PORT=$(GCP_DB_PROXY_PORT_PROD)
else
	GCP_DB_USER=$(GCP_DB_USER_DEV)
	GCP_DB_INSTANCE_CONNECTION_NAME=$(GCP_DB_INSTANCE_CONNECTION_NAME_DEV)
	GCP_DB_PASSWORD=$(GCP_DB_PASSWORD_DEV)
	GCP_DB_NAME=$(GCP_DB_NAME_DEV)
	GCP_DB_PROXY_PORT=$(GCP_DB_PROXY_PORT_DEV)
endif


bootstrap:
	mkdir -p $(GOPATH)/src
	./tools/setup_go_path_symlink.sh
	# include $GOPATH/bin as part of system path
	grep -q -F 'export PATH=$$PATH:$$GOPATH/bin' ~/.bashrc || echo 'export PATH=$$PATH:$$GOPATH/bin' >> ~/.bashrc
	source ~/.bashrc
	cd $(GOPATH)/src/repodiff; go get github.com/GoogleCloudPlatform/cloudsql-proxy/cmd/cloud_sql_proxy; \
		go get github.com/golang/dep/cmd/dep; \
		dep ensure; \
		go build

run:
	go build;
	ROLE="dev" ./repodiff

run_prod:
	go build;
	ROLE="prod" ./repodiff

reformat:
	go fmt .

db_shell:
	mysql -u $(GCP_DB_USER) -h 127.0.0.1 -P $(GCP_DB_PROXY_PORT) -p$(GCP_DB_PASSWORD) $(GCP_DB_NAME) ${EXTRA}

db_proxy:
	$(GOPATH)/bin/cloud_sql_proxy -instances=$(GCP_DB_INSTANCE_CONNECTION_NAME_DEV)=tcp:$(GCP_DB_PROXY_PORT_DEV) &
	$(GOPATH)/bin/cloud_sql_proxy -instances=$(GCP_DB_INSTANCE_CONNECTION_NAME_PROD)=tcp:$(GCP_DB_PROXY_PORT_PROD) &

db_proxy_ignore_err:
	make db_proxy; true

start_sql:
	make db_proxy_ignore_err &
	make db_shell < $(SQL_SCRIPT_DIR)/required_meta.sql

db_upgrade:
	make start_sql
	python tools/upgrade_db.py upgrade $(SQL_SCRIPT_DIR)


db_downgrade:
	make start_sql
	python tools/upgrade_db.py downgrade $(SQL_SCRIPT_DIR)

example:
	make db_shell EXTRA="-e 'DESCRIBE project_differential;'"

test:
	rm -rf build/
	ROLE="dev" go test ./... -v | grep -v PASS | grep -v RUN

sql_script:
	python tools/create_sql_script.py

ssh:
	 gcloud compute --project $(PROJECT_NAME) ssh --zone $(GCE_ZONE) $(REMOTE_MACHINE_NAME)

deploy:
	gcloud config set project $(PROJECT_NAME)
	@echo "Starting docker image build"
	make build_container_image
	@echo "Creating machine if it doesn't already exist"
	gcloud compute instances create $(REMOTE_MACHINE_NAME) \
		--machine-type $(GCE_MACHINE_TYPE) \
		--boot-disk-size $(DISK_SIZE) \
		--scopes https://www.googleapis.com/auth/source.read_only,https://www.googleapis.com/auth/compute \
		--zone $(GCE_ZONE) \
		--local-ssd interface=nvme \
		--metadata-from-file startup-script=remote_scripts/gce_startup.sh \
		--metadata AUTHOR=$(USER),SERVICE_ACCOUNT=$(SERVICE_ACCOUNT),GOOGLE_PROJECT_ID=$(GOOGLE_PROJECT_ID) \
		--image-project $(GCE_IMAGE_PROJECT) \
		--image-family $(GCE_IMAGE_FAMILY) \
		--min-cpu-platform skylake \
		--service-account $(SERVICE_ACCOUNT) \
		2>/dev/null || true
	@echo "Hackily waiting a bit for instance to start up"
	# TODO(slobdell) need to add a mechanism to block until startup script has completed
	@sleep 60
	./tools/clear_service_account_keys.py $(SERVICE_ACCOUNT) 2>/dev/null || true
	gcloud iam service-accounts keys create $(TMP_CREDENTIAL_FNAME) --iam-account $(SERVICE_ACCOUNT)
	$(RUN_COMMAND_REMOTE) 'mkdir -p /tmp/scripts'
	$(SCP_TO_HOST) remote_scripts/* "$(REMOTE_MACHINE_NAME)":/tmp/scripts/
	$(SCP_TO_HOST) $(TMP_CREDENTIAL_FNAME) "$(REMOTE_MACHINE_NAME)":/tmp/
	rm $(TMP_CREDENTIAL_FNAME)
	@echo "Stopping all existing docker images"
	$(RUN_COMMAND_REMOTE) 'docker stop $$(docker ps -a -q)' 2>/dev/null || true
	docker image save $(DOCKER_CANONICAL_ID) -o transferrable_docker_image.tar \
	  && $(SCP_TO_HOST) transferrable_docker_image.tar "$(REMOTE_MACHINE_NAME)":~/transferred_docker_image.tar \
    && $(RUN_COMMAND_REMOTE) 'docker load -i transferred_docker_image.tar' \
    && $(RUN_COMMAND_REMOTE) 'docker run -d --rm -p $(DOCKER_TARGET_PORT):$(DOCKER_TARGET_PORT) $(DOCKER_CANONICAL_ID)' \
		&& gcloud compute firewall-rules create $(FIREWALL_NAME) --allow tcp:$(DOCKER_TARGET_PORT) 2>/dev/null || true \
		&& gcloud compute firewall-rules update $(FIREWALL_NAME) --allow tcp:$(DOCKER_TARGET_PORT) --source-tags="$(REMOTE_MACHINE_NAME)" --source-ranges=0.0.0.0/0 --description="Allow requests over HTTP"
	@make output_instance_url --no-print-directory
	@rm transferrable_docker_image.tar

output_instance_url:
	@echo "Monitor progress at http://"$(shell (gcloud compute instances list | grep $(REMOTE_MACHINE_NAME) | awk -F ' ' '{print $$5}')):$(DOCKER_TARGET_PORT)/health

destroy:
	gcloud compute instances delete $(REMOTE_MACHINE_NAME) --zone $(GCE_ZONE) --quiet

############## DOCKER DEPLOYMENT
build_container_image:
	mkdir -p ./build
	# move contents of entire directory into build
	find . -type f -not -path 'build' -exec cp --parents '{}' 'build/' \;
	# copy python scripts repo uses, TODO re-structure codebase so the dependencies align with file structure
	cp ../../*.{txt,py} build/
	# Application credentials must be downloaded from https://pantheon.corp.google.com; set this environment variable to the path of the downloaded file
	cp $(GOOGLE_APPLICATION_CREDENTIALS) build/
	# copy local environment variables into Dockerfile
	cat Dockerfile | envsubst > build/Dockerfile
	# copy permissions from local gitcookies into Dockerfile (container will sync repo as you)
	cp static/docker_git_config ./build/.gitconfig
	cp ~/.gitcookies ./build/.gitcookies
	docker build -t $(DOCKER_CANONICAL_ID) ./build
	rm -rf ./build

docker_shell:
	docker run -it --rm $(DOCKER_CANONICAL_ID) bash

upload_container_image:
	gcloud config set project $(GOOGLE_PROJECT_ID)
	gcloud docker -- push $(DOCKER_CANONICAL_ID)

run_container_local:
	docker run --rm -p $(DOCKER_TARGET_PORT):$(DOCKER_TARGET_PORT) $(DOCKER_CANONICAL_ID)

create_container_cluster:
	gcloud container clusters create $(DOCKER_CLUSTER_NAME) \
		--num-nodes=3 \
		--machine-type $(GCE_MACHINE_TYPE) \
	  --zone $(GCE_ZONE)

create_container_cluster_verify:
	gcloud compute instances list

expose_to_internets:
	kubectl expose deployment $(DOCKER_DEPLOYMENT_NAME) --type=LoadBalancer --port $(PORT_HTTP) --target-port $(DOCKER_TARGET_PORT)

expose_to_internets_verify:
	kubectl get service

scale:
	kubectl scale deployment $(DOCKER_DEPLOYMENT_NAME) --replicas=$(DOCKER_REPLICA_COUNT)

cleanup:
	kubectl delete service
############## END DOCKER DEPLOYMENT

=== ide/clion/hardware/interfaces/graphics/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(hardware_graphics)

include("${CMAKE_CURRENT_SOURCE_DIR}/../../../CMakeLists.txt")

try_add_subdir(allocator/aidl/vts/VtsHalGraphicsAllocatorAidl_TargetTest)
try_add_subdir(allocator/aidl/android.hardware.graphics.allocator-V2-ndk)
try_add_subdir(composer/aidl/android.hardware.graphics.composer3-V2-ndk)
try_add_subdir(composer/aidl/vts/VtsHalGraphicsComposer3_TargetTest)
try_add_subdir(common/aidl/android.hardware.graphics.common-V5-ndk)
try_add_subdir(mapper/stable-c/libimapper_providerutils_tests)
try_add_subdir(mapper/stable-c/VtsHalGraphicsMapperStableC_TargetTest)
try_add_subdir(mapper/4.0/vts/functional/VtsHalGraphicsMapperV4_0TargetTest)

=== ide/clion/frameworks/base/libs/hwui/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(hwui)

set(ROOT ${CMAKE_CURRENT_LIST_DIR}/../../../../)
set(ROOT_OUT ${CMAKE_CURRENT_LIST_DIR}/cmake_out)

# HWUI deps that we want source for
add_subdirectory(${ROOT}/frameworks/native/libs/gui/libgui-arm64-android ${ROOT_OUT}/libgui)
add_subdirectory(${ROOT}/frameworks/native/libs/ui/libui-arm64-android ${ROOT_OUT}/libui)
add_subdirectory(${ROOT}/external/skia/libskia-arm64-android ${ROOT_OUT}/libskia)

# HWUI
add_subdirectory(${ROOT}/frameworks/base/libs/hwui/libhwui-arm64-android ${ROOT_OUT}/libhwui)
add_subdirectory(${ROOT}/frameworks/base/libs/hwui/hwuimacro-arm64-android ${ROOT_OUT}/hwuimacro)
add_subdirectory(${ROOT}/frameworks/base/libs/hwui/hwuimicro-arm64-android ${ROOT_OUT}/hwuimicro)
add_subdirectory(${ROOT}/frameworks/base/libs/hwui/hwui_unit_tests-arm64-android ${ROOT_OUT}/hwuiunit)

# JNI
add_subdirectory(${ROOT}/frameworks/base/core/jni/libandroid_runtime-arm64-android ${ROOT_OUT}/jni)

=== ide/clion/frameworks/base/tools/aapt2/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project("Android Resources")

set(ROOT ${CMAKE_CURRENT_LIST_DIR}/../../../../)
set(ROOT_OUT ${CMAKE_CURRENT_LIST_DIR}/cmake_out)
set(AAPT2_BASE ${ROOT}/frameworks/base/tools/aapt2)
set(IDMAP2_BASE ${ROOT}/frameworks/base/cmds/idmap2)
set(ANDROIDFW_BASE ${ROOT}/frameworks/base/libs/androidfw)
set(JNI_BASE ${ROOT}/frameworks/base/core/jni)
set(AAPT_BASE ${ROOT}/frameworks/base/tools/aapt)

# Set host arch
if(EXISTS ${AAPT2_BASE}/aapt2-x86_64-linux_glibc)
    message(NOTICE, "Applying HOST_ARCH x86_64-linux_glibc")
    set(HOST_ARCH x86_64-linux_glibc)
elseif(EXISTS ${AAPT2_BASE}/aapt2-x86-linux_glibc)
    message(NOTICE, "Applying HOST_ARCH x86-linux_glibc")
    set(HOST_ARCH x86-linux_glibc)
elseif(EXISTS ${AAPT2_BASE}/aapt2-x86_64-windows)
    message(NOTICE, "Applying HOST_ARCH x86_64-windows")
    set(HOST_ARCH x86_64-windows)
elseif(EXISTS ${AAPT2_BASE}/aapt2-x86-windows)
    message(NOTICE, "Applying HOST_ARCH x86-windows")
    set(HOST_ARCH x86-windows)
else()
    message(NOTICE, "Applying default HOST_ARCH x86_64-linux_glibc")
    set(HOST_ARCH x86_64-linux_glibc)
endif()

# Set target arch
if(EXISTS ${IDMAP2_BASE}/idmap2-arm64-android)
    message(NOTICE, "Applying TARGET_ARCH arm64-android")
    set(TARGET_ARCH arm64-android)
elseif(EXISTS ${IDMAP2_BASE}/idmap2-arm-android)
    message(NOTICE, "Applying TARGET_ARCH arm-android")
    set(TARGET_ARCH arm-android)
elseif(EXISTS ${IDMAP2_BASE}/idmap2-x86_64-linux_glibc)
    message(NOTICE, "Applying TARGET_ARCH x86_64-linux_glibc")
    set(TARGET_ARCH x86_64-linux_glibc)
elseif(EXISTS ${IDMAP2_BASE}/idmap2-x86-linux_glibc)
    message(NOTICE, "Applying TARGET_ARCH x86-linux_glibc")
    set(TARGET_ARCH x86-linux_glibc)
else()
    message(NOTICE, "Applying default TARGET_ARCH arm64-android")
    set(TARGET_ARCH arm64-android)
endif()

# aapt2
add_subdirectory(${AAPT2_BASE}/aapt2-${HOST_ARCH} ${ROOT_OUT}/aapt2)
add_subdirectory(${AAPT2_BASE}/aapt2_tests-${HOST_ARCH} ${ROOT_OUT}/aapt2_tests)
add_subdirectory(${AAPT2_BASE}/libaapt2-${HOST_ARCH} ${ROOT_OUT}/libaapt2)

# idmap2
add_subdirectory(${IDMAP2_BASE}/idmap2-${TARGET_ARCH} ${ROOT_OUT}/idmap2)
add_subdirectory(${IDMAP2_BASE}/idmap2d-${TARGET_ARCH} ${ROOT_OUT}/idmap2d)
add_subdirectory(${IDMAP2_BASE}/libidmap2-${TARGET_ARCH} ${ROOT_OUT}/libidmap2)
add_subdirectory(${IDMAP2_BASE}/libidmap2_protos-${TARGET_ARCH} ${ROOT_OUT}/libidmap2_protos)
add_subdirectory(${IDMAP2_BASE}/libidmap2daidl-${TARGET_ARCH} ${ROOT_OUT}/libidmap2daidl)
add_subdirectory(${IDMAP2_BASE}/idmap2_tests-${TARGET_ARCH} ${ROOT_OUT}/idmap2_tests)

# Android Runtime
add_subdirectory(${ANDROIDFW_BASE}/libandroidfw-${TARGET_ARCH} ${ROOT_OUT}/libandroidfw)
add_subdirectory(${ANDROIDFW_BASE}/libandroidfw_tests-${TARGET_ARCH} ${ROOT_OUT}/libandroidfw_tests)
add_subdirectory(${ANDROIDFW_BASE}/libandroidfw_benchmarks-${TARGET_ARCH} ${ROOT_OUT}/libandroidfw_benchmarks)
add_subdirectory(${ANDROIDFW_BASE}/libandroidfw_fuzzer_lib-${TARGET_ARCH} ${ROOT_OUT}/libandroidfw_fuzzer_lib)
add_subdirectory(${ANDROIDFW_BASE}/fuzz/resourcefile_fuzzer/resourcefile_fuzzer-${TARGET_ARCH}
        ${ROOT_OUT}/fuzz/resourcefile_fuzzer/resourcefile_fuzzer)

# JNI
add_subdirectory(${JNI_BASE}/libandroid_runtime-${TARGET_ARCH} ${ROOT_OUT}/jni)

# aapt
add_subdirectory(${AAPT_BASE}/aapt-${HOST_ARCH} ${ROOT_OUT}/aapt)
add_subdirectory(${AAPT_BASE}/libaapt-${HOST_ARCH} ${ROOT_OUT}/libaapt)
add_subdirectory(${AAPT_BASE}/libaapt_tests-${HOST_ARCH} ${ROOT_OUT}/libaapt_tests)

=== debian/changelog ===
android-platform-tools (35.0.2-1~exp6) experimental; urgency=medium

  * debian/system/libutils.mk: Add back source file under
    system/core/libutils/binder.

 -- Roger Shimizu <rosh@debian.org>  Fri, 18 Jul 2025 18:21:31 +0200

android-platform-tools (35.0.2-1~exp5) experimental; urgency=medium

  * d/system/libbacktrace.mk: Add -lzstd to fix autopkgtest regression.

 -- Roger Shimizu <rosh@debian.org>  Wed, 16 Jul 2025 21:17:07 +0200

android-platform-tools (35.0.2-1~exp4) experimental; urgency=medium

  * d/rules: Use dh_makeshlibs to specify the lib version (Closes: #1024902)
  * d/rules: Update the lib dependencies to fix FTBFS with make --shuffle=reverse
    (Closes: #1105254).

 -- Roger Shimizu <rosh@debian.org>  Sun, 13 Jul 2025 22:04:00 +0200

android-platform-tools (35.0.2-1~exp3) experimental; urgency=medium

  * debian/android-libutils-dev.install: Add libutils include folder.

 -- Roger Shimizu <rosh@debian.org>  Sun, 04 May 2025 19:17:17 -0700

android-platform-tools (35.0.2-1~exp2) experimental; urgency=medium

  * debian/rules: Bump up c&cpp std version.
  * debian/control:
    - Replace "android-sdk-platform-tools-common" with "android-udev-rules"
      and bump from "Recommends" to "Depends" as well.

 -- Roger Shimizu <rosh@debian.org>  Thu, 03 Apr 2025 23:17:23 -0700

android-platform-tools (35.0.2-1~exp1) experimental; urgency=medium

  * New upstream release 35.0.2
  * debian/patches:
    - Refresh patches.
    - Add patch to support MIPS for Android-V.
    - Amend patch to keep local "debian" version.
  * debian/control: Add B-D: libusb-1.0-0-dev (>= 2:1.0.28)
    which supports USB SuperSpeed+ Capability.
  * debian/adb.mk: Add dummy function 'using_bonjour' to dummy.cpp
  * Add debian/gbp.conf

 -- Roger Shimizu <rosh@debian.org>  Sun, 30 Mar 2025 23:03:17 -0700

android-platform-tools (34.0.5-11) unstable; urgency=medium

  * adb manpage: Make NAME one line to resolve lintian warning.
  * Update adbd.service:
    - Start adbd service after network is connected.
    - Add doc entry to service to resolve lintian warning.

 -- Roger Shimizu <rosh@debian.org>  Sun, 30 Mar 2025 18:14:16 -0700

android-platform-tools (34.0.5-10) unstable; urgency=medium

  * man: Use packages/modules/adb/docs/user/adb.1.md
  * Revert: Try to add alpha sh4 for adb/fastboot, due to no clang support.

 -- Roger Shimizu <rosh@debian.org>  Wed, 26 Mar 2025 00:43:12 -0700

=== debian/control ===
Source: android-platform-tools
Section: devel
Priority: optional
Maintainer: Android Tools Maintainers <android-tools-devel@lists.alioth.debian.org>
Uploaders:
 Roger Shimizu <rosh@debian.org>,
Build-Depends:
 bash-completion,
 debhelper-compat (= 13),
 dh-exec,
Build-Depends-Arch:
 7zip (>= 22.01+dfsg-9) [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64],
 android-libboringssl-dev (>= 12) [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64],
 clang [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el s390x ppc64 sparc64 riscv64],
 libbrotli-dev [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64],
 libcap-dev [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64],
 libgtest-dev,
 liblz4-dev [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64],
 libpng-dev,
 libprotobuf-dev (>= 3.12) [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64],
 libsquashfuse-dev [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64],
 libsystemd-dev [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64],
 libusb-1.0-0-dev (>= 2:1.0.28) [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64],
 libzstd-dev [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64],
 lld [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el],
 pandoc [amd64 i386 armel armhf arm64 ia64 loong64 mipsel mips64el ppc64el s390x ppc64 riscv64],
 protobuf-compiler (>= 3.12) [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64],
 python3 [amd64 i386 arm64],
 ronn [alpha arc hppa hurd-i386 kfreebsd-amd64 kfreebsd-i386 m68k powerpc sh4 sparc64 x32],
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/android-tools-team/android-platform-tools.git
Vcs-Browser: https://salsa.debian.org/android-tools-team/android-platform-tools
Homepage: https://developer.android.com/studio/releases/platform-tools

Package: android-sdk-libsparse-utils
Architecture: any
Multi-Arch: foreign
Section: utils
Depends: ${misc:Depends}, ${shlibs:Depends},
         python3,
Breaks: android-tools-fsutils,
        append2simg (<< 1:10.0.0+r36-1~),
        img2simg (<< 1:10.0.0+r36-1~),
        simg2img (<< 1:10.0.0+r36-1~)
Replaces: android-tools-fsutils,
          append2simg (<< 1:10.0.0+r36-1~),
          img2simg (<< 1:10.0.0+r36-1~),
          simg2img (<< 1:10.0.0+r36-1~)
Description: Android sparse image creation tool
 Command line tools to create sparse images for usage with Android devices.
 Includes simg2img, img2simg, simg2simg, simg_dump and append2simg tools.

Package: android-liblog
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
Breaks: android-liblog-dev (<< 1:33)
Description: Android NDK logger interfaces
 liblog represents an interface to the volatile Android Logging system for NDK
 (Native) applications and libraries. Interfaces for either writing or reading
 logs. The log buffers are divided up in Main, System, Radio and Events
 sub-logs.

Package: android-liblog-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         android-liblog (= ${binary:Version}),
Breaks: android-liblog (<< 1:33)
Replaces: android-liblog (<< 1:33)
Description: Android NDK logger interfaces - Development files
 liblog represents an interface to the volatile Android Logging system for NDK
 (Native) applications and libraries. Interfaces for either writing or reading
 logs. The log buffers are divided up in Main, System, Radio and Events
 sub-logs.
 .
 This package contains the development files.

Package: android-libcutils
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
         libbsd0,
Breaks: android-libcutils-dev (<< 1:33)
Description: Android utils library for C
 This library provides common functionalities for android related tools.
 .
 This library is only used by Android SDK currently.

Package: android-libcutils-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         android-libcutils (= ${binary:Version}),
         android-libbase-dev (= ${binary:Version}),
         android-platform-system-core-headers (= 1:${source:Version}),
         libbsd-dev,
Breaks: android-libcutils (<< 1:33)
Replaces: android-libcutils (<< 1:33)
Description: Android utils library for C - Development files
 This library provides common functionalities for android related tools.
 .
 This library is only used by Android SDK currently.
 .
 This package contains the development files.

Package: adb
Section: utils
Architecture: amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends},
         android-udev-rules,
Provides: android-tools-adb
Description: Android Debug Bridge
 A versatile command line tool that lets you communicate with an emulator
 instance or connected Android-powered device.
 .
 This package depends on "android-udev-rules" which contains
 the udev rules for Android devices. Without this package, adb and fastboot need
 to be running with root permission.

Package: adbd
Section: utils
Architecture: amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends},
Breaks: android-tools-adbd (<< 6.0~)
Replaces: android-tools-adbd (<< 6.0~)
Provides: android-tools-adbd
Description: Android Debug Bridge daemon
 Android Debug Bridge (adb) is a versatile tool that lets you manage the state
 of an emulator instance or Android-powered device. It is a client-server
 program that includes three components:
 .
 A client, which runs on your development machine. You can invoke a
 client from a shell by issuing an adb command. Other Android tools such
 as the ADT plugin and DDMS also create adb clients.
 .
 A server, which runs as a background process on your development
 machine. The server manages communication between the client and the
 adb daemon running on an emulator or device.
 .
 A daemon, which runs as a background process on each emulator or device
 instance.
 .
 This package provides the daemon component.

Package: android-libsparse
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
Breaks: android-libsparse-dev (<< 1:33)
Description: Library for sparse files
 This library provides APIs for creating, manipulating and destroying sparse
 files.
 .
 This library is only used by Android SDK currently.

Package: android-libsparse-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         android-libsparse (= ${binary:Version}),
Breaks: android-libsparse (<< 1:33)
Replaces: android-libsparse (<< 1:33)
Description: Library for sparse files - Development files
 This library provides APIs for creating, manipulating and destroying sparse
 files.
 .
 This library is only used by Android SDK currently.
 .
 This package contains the development files.

Package: android-libutils
Section: libs
Architecture: amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
Breaks: android-libutils-dev (<< 1:33)
Description: Android Utility Function Library
 This library provides miscellaneous utility functions.
 .
 This library is only used by Android SDK currently.

Package: android-libutils-dev
Section: libdevel
Architecture: amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64
Multi-Arch: same
Depends: ${misc:Depends},
         android-libbacktrace-dev (= ${binary:Version}),
         android-libcutils-dev (= ${binary:Version}),
         android-libutils (= ${binary:Version}),
         android-platform-system-core-headers (= 1:${source:Version}),
Breaks: android-libutils (<< 1:33)
Replaces: android-libutils (<< 1:33)
Description: Android Utility Function Library - Development files
 This library provides miscellaneous utility functions.
 .
 This library is only used by Android SDK currently.
 .
 This package contains the development files.

Package: android-libziparchive
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
Breaks: android-libziparchive-dev (<< 1:33)
Description: Library for ZIP archives
 This library provides APIs for creating and manipulating ZIP archives.
 .
 This library is only used by Android SDK currently.

Package: android-libziparchive-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         android-libziparchive (= ${binary:Version}),
         libgtest-dev,
Breaks: android-libziparchive (<< 1:33)
Replaces: android-libziparchive (<< 1:33)
Description: Library for ZIP archives - Development files
 This library provides APIs for creating and manipulating ZIP archives.
 .
 This library is only used by Android SDK currently.
 .
 This package contains the development files.

Package: android-platform-frameworks-native-headers
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Headers of android-platform-frameworks-native
 This package contains headers in include/android in platform/frameworks/native
 Consists of all the header files ranging from asset_manager.h to window.h.

Package: android-platform-system-core-headers
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: android-libunwind-dev (<< 10.0.0+r36-5)
Replaces: android-libunwind-dev (<< 10.0.0+r36-5)
Description: Shared headers in AOSP repository platform/system/core
 This package contains header files in AOSP repository platform/system/core that
 do not belong to any specific libraries but used by other programs.
 .
 This package currently contains headers in include/private and include/system.

Package: android-libbacktrace
Section: libs
Architecture: amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
         7zip,
Breaks: android-libbacktrace-dev (<< 1:33)
Description: Android backtrace library
 Android backtrace library produce symbolic backtraces for making
 debugging easier.

Package: android-libbacktrace-dev
Section: libdevel
Architecture: amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64
Multi-Arch: same
Depends: ${misc:Depends},
         android-libbacktrace (= ${binary:Version}),
Breaks: android-libbacktrace (<< 1:33)
Replaces: android-libbacktrace (<< 1:33)
Description: Android backtrace library - Development files
 Android backtrace library produce symbolic backtraces for making
 debugging easier.
 .
 This package contains the development files.

Package: android-libbase
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
Breaks: android-libbase-dev (<< 1:33)
Description: Android base library
 This library provides APIs for basic tasks like handling files, Unicode
 strings, logging, memory allocation, integer parsing, etc..
 .
 This library is only used by Android SDK currently.

Package: android-libbase-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         android-libbase (= ${binary:Version}),
         android-liblog-dev (= ${binary:Version}),
Breaks: android-libbase (<< 1:33)
Replaces: android-libbase (<< 1:33)
Description: Android base library - Development files
 This library provides APIs for basic tasks like handling files, Unicode
 strings, logging, memory allocation, integer parsing, etc..
 .
 This library is only used by Android SDK currently.
 .
 This package contains the development files.

Package: android-libnativehelper
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
Breaks: android-libnativehelper-dev (<< 33)
Replaces: android-libnativehelper-dev (<< 33)
Description: Support functions for Android's class libraries

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

## Security Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# https://android.googlesource.com/platform/build/soong/+/refs/tags/platform-tools-35.0.2/cc/config/global.go#393
export DEB_CFLAGS_MAINT_APPEND = -fPIC -std=gnu2x
export DEB_CXXFLAGS_MAINT_APPEND = -fPIC -std=gnu++2b
export DEB_LDFLAGS_MAINT_APPEND = -fPIC
export DEB_CPPFLAGS_MAINT_APPEND = -DNDEBUG -UDEBUG \
  -fmessage-length=0 \
  -fno-exceptions \
  -fno-strict-aliasing \
  -no-canonical-prefixes \

## For get-orig-source
export DEB_SOURCE

## system
export DEB_HOST_MULTIARCH
export DEB_VERSION
# https://android.googlesource.com/platform/development/+/refs/tags/platform-tools-35.0.2/sdk/plat_tools_source.prop_template
export PLATFORM_TOOLS_VERSION = 35.0.2

ifneq (, $(shell which clang))
  export CC = clang
  export CXX = clang++
  export DEB_CFLAGS_MAINT_APPEND += -gdwarf-4
  export DEB_CXXFLAGS_MAINT_APPEND += -gdwarf-4
  export DEB_CPPFLAGS_MAINT_APPEND += \
    -Wno-c99-designator \
    -Wno-gnu-designator \
    -Wno-gnu-folding-constant \

endif
ifneq (, $(shell which lld))
  export DEB_LDFLAGS_MAINT_APPEND += -fuse-ld=lld -Wl,--build-id=sha1
endif

%:
	dh $@ --with bash-completion

# Depends: git-buildpackage repo ssh
get-orig-source:
	debian/scripts/get-orig-source

ifeq ("$(wildcard ../$(DEB_SOURCE)_$(PLATFORM_TOOLS_VERSION).orig.tar.xz)","")
update: get-orig-source
else
update:
endif
	gbp import-orig ../$(DEB_SOURCE)_$(PLATFORM_TOOLS_VERSION).orig.tar.xz \
		--no-interactive --debian-branch=$(shell git symbolic-ref --short HEAD) \
		--postimport="\
		dch -b -v\$$GBP_DEBIAN_VERSION \"New upstream release \$$GBP_UPSTREAM_VERSION\"; \
		git add debian/changelog; \
		git commit -m\"dch: Note new upstream version \$$GBP_UPSTREAM_VERSION\""

## system

s/lib%.a: debian/system/lib%.mk
	dh_auto_build --buildsystem=makefile -- --file=$<

s/lib%.so: debian/system/lib%.mk s/libbase.so
	dh_auto_build --buildsystem=makefile -- --file=$<

debian/manpages/system/%.1: debian/manpages/system/%.1.md
ifneq (, $(shell which pandoc))
	pandoc --standalone --from=markdown-smart --to=man --output=$@ $<
else
	ronn -r $<
endif

s/libbacktrace.so: debian/system/libbacktrace.mk s/libcutils.so e/libcpu_features.so
	dh_auto_build --buildsystem=makefile -- --file=$<

s/libbase.so: debian/system/libbase.mk s/liblog.so
	dh_auto_build --buildsystem=makefile -- --file=$<

s/liblog.so: debian/system/liblog.mk
	dh_auto_build --buildsystem=makefile -- --file=$<

s/adb: debian/system/adb.mk s/libziparchive.so s/libadb.a s/libcrypto_utils.a s/libcutils.so debian/manpages/system/adb.1
	dh_auto_build --buildsystem=makefile -- --file=$<

s/adbd: debian/system/adbd.mk s/libadb.a s/libcrypto_utils.a s/libcutils.so
	dh_auto_build --buildsystem=makefile -- --file=$<

s/fastboot: debian/system/fastboot.mk s/adb s/extras/libext4_utils.a s/libsparse.so debian/manpages/system/fastboot.1
	dh_auto_build --buildsystem=makefile -- --file=$<

s/simg2img: debian/system/simg2img.mk s/libbase.so s/libsparse.so
	dh_auto_build --buildsystem=makefile -- --file=$<

s/simg2simg: debian/system/simg2simg.mk s/simg2img
	dh_auto_build --buildsystem=makefile -- --file=$<

s/img2simg: debian/system/img2simg.mk s/simg2img
	dh_auto_build --buildsystem=makefile -- --file=$<

s/append2simg: debian/system/append2simg.mk s/simg2img
	dh_auto_build --buildsystem=makefile -- --file=$<

COMPONENTS = \
  e/libcpu_features.so \
  s/append2simg \
  s/img2simg \
  s/libbacktrace.so \
  s/libbase.so \
  s/libcutils.so \
  s/liblog.so \
  s/libsparse.so \
  s/libutils.so \
  s/libziparchive.so \
  s/simg2img \
  s/simg2simg \

# Whatever depends on BoringSSL must be disabled on MIPS
NON_MIPS_COMPONENTS = s/adb s/adbd s/fastboot
ifneq ($(filter amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64,$(DEB_HOST_ARCH)),)
  COMPONENTS += $(NON_MIPS_COMPONENTS)
endif

# Most components only support ARM, x86 and MIPS, but some can be built
# on all architectures.
COMPONENTS_ANY_ARCH = \
  s/append2simg \
  s/img2simg \
  s/libbase.so \
  s/libcutils.so \
  s/liblog.so \
  s/libsparse.so \
  s/libziparchive.so \
  s/simg2img \
  s/simg2simg \

ifeq ($(filter amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64,$(DEB_HOST_ARCH)),)
  COMPONENTS := $(filter $(COMPONENTS_ANY_ARCH), $(COMPONENTS))
endif

## development

debian/manpages/development/%.1: debian/manpages/development/%.1.md
ifneq (, $(shell which pandoc))
	pandoc --standalone --from=markdown-smart --to=man --output=$@ $<
else
	ronn -r $<
endif

development/etc1tool: debian/development/etc1tool.mk debian/manpages/development/etc1tool.1 f/native/libETC1.a
	dh_auto_build --buildsystem=makefile -- --file=$<

COMPONENTS += development/etc1tool

## frameworks/native

f/native/libETC1.a: debian/frameworks/native/libETC1.mk
	dh_auto_build --buildsystem=makefile -- --file=$<

COMPONENTS += f/native/libETC1.a

## system/extras

s/extras/libext4_utils.a: debian/system/extras/libext4_utils.mk
	dh_auto_build --buildsystem=makefile -- --file=$<

## libnativehelper

libnativehelper/libnativehelper.so: debian/libnativehelper/libnativehelper.mk s/liblog.so
	dh_auto_build --buildsystem=makefile -- --file=$<

COMPONENTS += libnativehelper/libnativehelper.so

## dalvik

dalvik/hprof-conv: debian/dalvik/hprof-conv.mk
	dh_auto_build --buildsystem=makefile -- --file=$<

COMPONENTS += dalvik/hprof-conv

## external

e/lib%.so: debian/external/lib%.mk
	dh_auto_build --buildsystem=makefile -- --file=$<

override_dh_auto_build-arch: $(COMPONENTS)

ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
override_dh_auto_test-arch:
	debian/out/development/etc1tool development/tools/templates/ic_launcher_ldpi.png --encode && debian/out/development/etc1tool development/tools/templates/ic_launcher_ldpi.pkm --decode
ifneq ($(filter amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64,$(DEB_HOST_ARCH)),)
	LD_LIBRARY_PATH=debian/out/system debian/out/system/adb version
	LD_LIBRARY_PATH=debian/out/system debian/out/system/adb help
	LD_LIBRARY_PATH=debian/out/system debian/out/system/adb keygen key.txt && ls -l key.txt* && rm key.txt*
	LD_LIBRARY_PATH=debian/out/system debian/out/system/adbd --version
	LD_LIBRARY_PATH=debian/out/system debian/out/system/fastboot --version
	LD_LIBRARY_PATH=debian/out/system debian/out/system/fastboot devices
endif
endif

override_dh_auto_install:
	echo ignore upstream build system install procedure

override_dh_auto_configure-arch:
	rm -rf development/[a-s]* development/v* development/testrunner \
		external/lzma/{Asm,CPP,CS,DOC,Java} external/lzma/C/*.c external/lzma/C/Util
	mkdir -p debian/out/dalvik/tools debian/out/development debian/out/external \
		debian/out/frameworks/native debian/out/system/extras debian/out/libnativehelper
ifneq ($(filter amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64,$(DEB_HOST_ARCH)),)
	for proto in packages/modules/adb/fastdeploy/proto packages/modules/adb/proto; do \
		(cd $$proto && \
			find . -name '*.proto' -printf 'Regenerate %p\n' \
			-exec protoc --cpp_out=. {} \;) \
	done
endif

override_dh_gencontrol:
	dh_gencontrol
	dh_gencontrol -padb -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libbacktrace -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libbacktrace-dev -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libbase -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libbase-dev -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libcutils -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libcutils-dev -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-liblog -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-liblog-dev -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libsparse -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libsparse-dev -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libutils -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libutils-dev -- -v1:$(DEB_VERSION)
